<template>
  <div class="sidebar">
    <el-dialog
      v-model="showSidebar"
      :before-close="toggleSidebar"
      destroy-on-close
      width="260px"
      custom-class="sidebar-dialog"
      :show-close="false"
    >
      <div class="h-[90vh] px-4 py-2 mx-auto overflow-none overflow-scroll">
        <div class="flex flex-col items-center gap-2 pb-2">
          <div
            v-if="menuTabHeaders.length > 0"
            class="flex flex-col items-start w-full p-0"
          >
            <new-black-theme-sidebar-menu
              v-for="menu in menuTabHeaders"
              :key="menu"
              :menu="menu"
            />
          </div>
          <div
            v-if="isAllowPromotionTab"
            class="border border-solid border-[color:var(--border)] opacity-50 w-full"
          ></div>
          <div
            v-if="isAllowPromotionTab"
            class="flex flex-row items-center justify-between w-full gap-8 py-3 h-11"
          >
            <nuxt-link to="/Promotion" class="w-full" @click="toggleSidebar">
              <div
                class="flex flex-row justify-between items-center py-3 gap-[39px] h-11 w-full"
              >
                <div class="flex flex-row items-center h-5 gap-2 p-0">
                  <div class="w-5 h-5">
                    <svg-icon
                      svg-name="icon-promotion-2"
                      class="icon w-[17px] h-[17px]"
                    />
                  </div>
                  <span class="uppercase sidebar-text">{{
                    $t("promotion")
                  }}</span>
                </div>
                <div class="flex items-center m-angle-right-container">
                  <font-awesome-icon
                    icon="angle-right"
                    class="icon-angle-right"
                  />
                </div>
              </div>
            </nuxt-link>
          </div>
          <div
            class="border border-solid border-[color:var(--border)] opacity-50 w-full"
          ></div>
          <div
            v-if="!agentCooperation.IsHidden"
            class="flex flex-row justify-between items-center py-3 gap-[39px] h-11 w-full mb-[-0.5rem] cursor-pointer"
            @click="toggleAgentCooperation"
          >
            <div class="flex flex-row items-center h-5 gap-2 p-0">
              <div>
                <svg-icon
                  svg-name="icon-people-peru"
                  class="object-contain w-5 h-4"
                />
              </div>
              <span class="sidebar-text">{{ $t("agent_cooperation") }}</span>
            </div>
            <div class="flex items-center m-angle-right-container">
              <font-awesome-icon icon="angle-right" />
            </div>
          </div>
          <nuxt-link
            v-if="getContactList.length"
            to="/contact-us"
            class="w-full"
            @click="toggleSidebar"
          >
            <div class="flex flex-row justify-between items-center py-3 gap-[39px] h-11 w-full mb-[-0.5rem] cursor-pointer">
              <div class="content flex flex-row items-center h-5 gap-2 p-0">
                <div class="icon-container">
                  <SvgIcon svg-name="icon-contact-new" class="w-5 h-4" />
                </div>
                <span class="label uppercase text-sm">
                  {{ $t("contact") }}
                </span>
              </div>
              <div class="flex items-center m-angle-right-container">
                <font-awesome-icon icon="angle-right" />
              </div>
            </div>
          </nuxt-link>
          <nuxt-link v-if="authentication && !isAccount" to="/profile" class="w-full" @click="toggleSidebar">
            <div
              class="flex flex-row justify-between items-center py-3 gap-[39px] h-11 w-full"
            >
              <div class="flex flex-row items-center h-5 gap-2 p-0">
                <div class="w-5 h-5">
                  <svg-icon
                    svg-name="icon-fAccount"
                    class="w-[17px] h-[17px]"
                  />
                </div>
                <span class="sidebar-text">{{
                  $t("account")
                }}</span>
              </div>
              <div class="flex items-center m-angle-right-container">
                <font-awesome-icon
                  icon="angle-right"
                  class="icon-angle-right"
                />
              </div>
            </div>
          </nuxt-link>
          <div class="w-full" v-if="!authentication && !isLogin" @click="onLogin">
            <div
              class="cursor-pointer flex flex-row justify-between items-center py-3 gap-[39px] h-11 w-full"
              @click="toggleLoginRegisterDialog()"
            >
            <div class="flex flex-row items-center h-5 gap-2 p-0">
              <div class="w-5 h-5">
                <svg-icon
                  svg-name="icon-signout-peru"
                  class="icon w-[17px] h-[17px]"
                />
              </div>
              <span class="sidebar-text">
                {{ $t("capital_login") }}
              </span>
            </div>
              <div class="flex items-center m-angle-right-container">
                <font-awesome-icon
                  icon="angle-right"
                  class="icon-angle-right"
                />
              </div>
            </div>
          </div>
          <div class="w-full" v-if="authentication && !isSignOut" @click="onLogout">
            <div
              class="flex flex-row justify-between items-center py-3 gap-[39px] h-11 w-full"
            >
              <div class="flex flex-row items-center h-5 gap-2 p-0">
                <div class="w-5 h-5">
                  <svg-icon
                    svg-name="icon-signout-peru"
                    class="icon w-[17px] h-[17px]"
                  />
                </div>
                <span class="sidebar-text">{{
                  $t("logout")
                }}</span>
              </div>
              <div class="flex items-center m-angle-right-container">
                <font-awesome-icon
                  icon="angle-right"
                  class="icon-angle-right"
                />
              </div>
            </div>
          </div>
          <div
            class="flex flex-col w-full rounded-lg lang-wr-option-container"
          >
            <el-collapse>
              <el-collapse-item>
                <template #title>
                  <div class="flex items-center justify-between w-full">
                    <div class="flex items-center fc-text">
                      <div class="icon-lang">
                        <img
                          :src="
                            getAssetImage(
                              `assets/materials/languageIcon/square/${defaultLanguage}.png`
                            )
                          "
                        />
                      </div>
                      <span class="profile-menu-title">{{
                        defaultLanguageForDisplay
                      }}</span>
                    </div>
                    <div class="flex items-center m-angle-right-container">
                      <font-awesome-icon
                        icon="angle-down"
                        class="m-language-collapse"
                      />
                    </div>
                  </div>
                </template>
                <div>
                  <div v-for="lang in languages" :key="lang">
                    <div
                      class="flex items-center cursor-pointer padding-y fc-text"
                      @click="switchLanguage(lang.ISO)"
                    >
                      <div class="icon-lang">
                        <img
                          :src="
                            getAssetImage(
                              `assets/materials/languageIcon/square/${lang.ISO}.png`
                            )
                          "
                        />
                      </div>
                      <div class="profile-menu-title">
                        {{ lang.LanguageLocalName }}
                      </div>
                    </div>
                  </div>
                </div>
              </el-collapse-item>
            </el-collapse>
          </div>
        </div>
        <template v-if="isAppDownloadEnabled">
          <a v-if="appDownloadURL === ''" :href="appUrl" download>
            <div class="absolute bottom-0 right-0 rounded-t-2xl bg-theme-color">
              <div
                class="flex flex-row items-end justify-between h-16 gap-1 px-1"
              >
                <div class="w-[68px] h-[68px]">
                  <img
                    :src="
                      getAssetImage(
                        'assets/theme/new_black_theme/app_download.png'
                      )
                    "
                    alt=""
                  />
                </div>
                <div class="flex flex-row items-center p-0 gap-1 h-16 z-[1]">
                  <div
                    class="flex flex-col justify-center items-start p-0 h-16 w-[98px]"
                  >
                    <span class="app-download-title">{{ brandName }} APP</span>
                    <span class="app-download-content"
                      >Download <br />
                      our Android APP</span
                    >
                  </div>
                  <div class="w-[78px] h-[30px]">
                    <el-button type="primary" round class="capitalize bk8-downloadBtn" >{{
                      $t("download")
                    }}</el-button>
                  </div>
                </div>
              </div>
              <div class="bg-app-download" :style="`background-image: ${bgApp};`"></div>
            </div>
          </a>
          <a
            v-else
            :href="
              appDownloadURL.includes('://')
                ? appDownloadURL
                : `//${appDownloadURL}`
            "
            target="_blank"
          >
            <div class="absolute bottom-0 right-0 rounded-t-2xl bg-theme-color">
              <div
                class="flex flex-row items-end justify-between h-16 gap-1 px-1"
              >
                <div class="w-[68px] h-[68px]">
                  <img
                    :src="
                      getAssetImage(
                        'assets/theme/new_black_theme/app_download.png'
                      )
                    "
                    alt=""
                  />
                </div>
                <div class="flex flex-row items-center p-0 gap-1 h-16 z-[1]">
                  <div
                    class="flex flex-col justify-center items-start p-0 h-16 w-[98px]"
                  >
                    <span class="app-download-title">{{ brandName }} APP</span>
                    <span class="app-download-content"
                      >Download <br />
                      our Android APP</span
                    >
                  </div>
                  <div class="w-[78px] h-[30px]">
                    <el-button type="primary" round class="capitalize bk8-downloadBtn" >{{
                      $t("download")
                    }}</el-button>
                  </div>
                </div>
              </div>
              <div class="bg-app-download" :style="`background-image: ${bgApp};`"></div>
            </div>
          </a>
        </template>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import { store } from "@/store";
import {
  useHeaderComponent,
  useLanguageComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";

export default defineComponent({
  name: "Login",
  setup() {
    const authentication = computed(() => store.state.auth);
    const selectedThemeName = store.state.selectedThemeName;
    const { getContactList } = useContactUs();
    store.commit("updateSidebar", false);
    // store.commit("updateRegisterDialog", false);
    store.commit("updateAgentCooperationDialog", false);
    const toggleSidebar = () => {
      store.commit("updateSidebar", !store.state.showSidebar);
    };
    const toggleAgentCooperation = () => {
      store.commit(
        "updateAgentCooperationDialog",
        !store.state.showAgentCooperationDialog
      );
      store.commit("updateSidebar", !store.state.showSidebar);
    };
    const showSidebar = computed(() => store.state.showSidebar);
    const activeNames = ref([]);
    const { getAssetImage, toggleLoginRegisterDialog } = commonHelper;
    const handleImageRender = (img: string) => {
      let src = "";
      try {
        src = getAssetImage(
          `assets/theme/new_black_theme/sidebar/${img.replace(" ", "")}.svg`
        );
      } catch (_) {
        src = "";
      }
      return src;
    };
    const {
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
    } = useLanguageComponent();
    const {
      menuTabHeaders,
      appDownload,
      appUrl,
      isAppDownloadEnabled,
      isAllowPromotionTab,
      agentCooperation,
      logout,
      appDownloadURL,
    } = useHeaderComponent();
    const bgApp = `url(${getAssetImage(
      "assets/theme/new_black_theme/bg-app-download.png"
    )})`;
    const brandName =themePropertyHelper.getSingleThemeProperty(store.state.companyThemePropertiesFromApi.ThemeProperties, "seo_brand_name").Text;
    const { themeColor } = themePropertyHelper;
    const  theme  = themeColor.value.Text ;
    const onLogout = () => {
      logout();
    };
    const isLogin = computed(() => 
      featuresToggleHelper.getThemePropertyFromApi(
      EnumThemePropertyKey.HtmlId,
      "login").IsHidden
    );
    const isSignOut = computed(() =>
      featuresToggleHelper.getThemePropertyFromApi(
      EnumThemePropertyKey.HtmlId,
      "sign_out").IsHidden
    );
    const isAccount = computed(() =>
      featuresToggleHelper.getThemePropertyFromApi(
      EnumThemePropertyKey.HtmlId,
      "account").IsHidden
    );
    return {
      toggleSidebar,
      showSidebar,
      menuTabHeaders,
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
      activeNames,
      appDownload,
      appUrl,
      handleImageRender,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      authentication,
      getAssetImage,
      bgApp,
      isAppDownloadEnabled,
      isAllowPromotionTab,
      toggleAgentCooperation,
      agentCooperation,
      brandName,
      selectedThemeName,
      theme,
      onLogout,
      isLogin,
      isSignOut,
      isAccount,
      toggleLoginRegisterDialog,
      getContactList,
      appDownloadURL,
    };
  },
});
</script>

<style lang="scss" scoped>
:deep(button.el-button) {
  width: 78px;
  height: 30px;
  background-color: var(--primary);
  border: none;
}
:deep(.el-button span) {
  @apply text-[12px] font-bold leading-[14px] text-[color:var(--textBtn)];
}
.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;
  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}
.icon-lang {
  img {
    object-fit: cover;
  }
  height: 15px;
  width: 22px;
  border-radius: 2px;
  overflow: hidden;
}
.router-lint-active {
  .sidebar-text,
  .icon-angle-right {
    color: var(--selected) !important;
  }
}
</style>
<style>
.app-download-title {
  width: 98px;
  height: 14px;
  font-style: normal;
  font-weight: bold;
  font-size: 12px;
  line-height: 14px;
  color: var(--text5);
}
.app-download-content {
  font-weight: 300;
  font-size: 12px;
  line-height: 14px;
  color: var(--text5);
}
.bg-app-download {
  @apply absolute w-40 h-[3.75rem] left-[100px] top-1 rounded-t-2xl;
}
.bg-theme-color {
  @apply absolute w-[260px] h-16 left-[100px] bottom-0 rounded-t-2xl;
  left: calc(50% - 260px / 2);
  background: var(--background3);
}
.sidebar-text {
  @apply h-4 font-normal leading-4 text-sm;
  color: var(--text);
}
.m-profile-menu-item {
  border-bottom: 0.5px solid #393c68;
}
.m-profile-menu-item:last-child {
  border-bottom: none;
}
.m-angle-right-container {
  height: 21.83px;
  width: 21.83px;
  display: flex;
  justify-content: center;
  color: var(--text);
}
.m-angle-right-container svg {
  font-size: 16.31px;
}
.profile-menu-title {
  font-size: 14px;
  color: var(--text);
  margin-left: 8.73px;
}
.el-collapse-item__arrow {
  display: none;
}
.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}
.el-collapse-item .m-language-collapse {
  transition: transform 0.3s ease-in-out;
}
.el-collapse-item.is-active .m-language-collapse {
  transform: rotate(-180deg);
}
.el-collapse-item__content {
  padding-left: 10px;
}
.lang-wr-option-container {
  padding-top: 4.87px;
  padding-bottom: 4.87px;
  margin-bottom: 27px !important;
}
.padding-y {
  padding-top: 12.25px;
  padding-bottom: 12.25px;
}

@media screen and (min-width: 1024px) {
  .sidebar {
    display: none;
  }
}
</style>
